## Generated SDC file "LTC2320_cmos.out.sdc"

## Copyright (C) 1991-2012 Altera Corporation
## Your use of Altera Corporation's design tools, logic functions 
## and other software and tools, and its AMPP partner logic 
## functions, and any output files from any of the foregoing 
## (including device programming or simulation files), and any 
## associated documentation or information are expressly subject 
## to the terms and conditions of the Altera Program License 
## Subscription Agreement, Altera MegaCore Function License 
## Agreement, or other applicable license agreement, including, 
## without limitation, that your use is for the sole purpose of 
## programming logic devices manufactured by Altera and sold by 
## Altera or its authorized distributors.  Please refer to the 
## applicable agreement for further details.


## VENDOR  "Altera"
## PROGRAM "Quartus II"
## VERSION "Version 12.1 Build 177 11/07/2012 SJ Web Edition"

## DATE    "Tue Feb 10 15:53:23 2015"

##
## DEVICE  "EP3C5E144C7"
##

#**************************************************************
# Time Information
#**************************************************************
set_time_format -unit ns -decimal_places 3

#**************************************************************
# Create Clock
#**************************************************************
#derive_clocks -period 13.333

create_clock -name {clkin} -period 13.333 [get_ports {CLKIN}]

#DDR frequencies
create_clock -period 6.666 -waveform {3.333 6.666} -name sckn SCKn
create_clock -period 13.333 -name cnvclk CNVCLK~reg0
create_clock -period 666.666 -waveform {202.5 209.18} -name data_latch pulse_generator:pulses|data_latch

#**************************************************************
# Create Generated Clock
#**************************************************************
#derive_pll_clocks
create_generated_clock -source {synchronize|altpll_component|auto_generated|pll1|inclk[0]} -multiply_by 2 -duty_cycle 50.00 -name clk_150 {synchronize|altpll_component|auto_generated|pll1|clk[0]}

create_generated_clock -source {synchronize|altpll_component|auto_generated|pll1|inclk[0]} -multiply_by 2 -phase 225 -duty_cycle 50.00 -name rx_clk_150 {synchronize|altpll_component|auto_generated|pll1|clk[1]}

create_generated_clock -source {synchronize|altpll_component|auto_generated|pll1|inclk[0]} -multiply_by 4 -duty_cycle 50.00 -name clk_300 {synchronize|altpll_component|auto_generated|pll1|clk[2]}

create_generated_clock -source {synchronize|altpll_component|auto_generated|pll1|inclk[0]} -multiply_by 4 -phase 90 -duty_cycle 50.00 -name rx_clk_300 {synchronize|altpll_component|auto_generated|pll1|clk[3]}

create_generated_clock -source {synchronize|altpll_component|auto_generated|pll1|inclk[0]} -divide_by 50 -offset 0.83 -duty_cycle 9.00 -name sync {synchronize|altpll_component|auto_generated|pll1|clk[4]}

#**************************************************************
# Set Clock Latency
#**************************************************************

#**************************************************************
# Set Clock Uncertainty
#**************************************************************
derive_clock_uncertainty 

#**************************************************************
# Set Input Delay
#**************************************************************
set_input_delay -clock [get_clocks {sckn}] -min 0 [get_ports {SDO_An}]
set_input_delay -clock [get_clocks {sckn}] -max 4.5 [get_ports {SDO_An}]
set_input_delay -clock [get_clocks {sckn}] -min 0 [get_ports {SDO_Bn}]
set_input_delay -clock [get_clocks {sckn}] -max 4.5 [get_ports {SDO_Bn}]
set_input_delay -clock [get_clocks {sckn}] -min 0 [get_ports {SDO_Cn}]
set_input_delay -clock [get_clocks {sckn}] -max 4.5 [get_ports {SDO_Cn}]
set_input_delay -clock [get_clocks {sckn}] -min 0 [get_ports {SDO_Dn}]
set_input_delay -clock [get_clocks {sckn}] -max 4.5 [get_ports {SDO_Dn}]

#**************************************************************
# Set Output Delay
#**************************************************************
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D0}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D1}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D2}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D3}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D4}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D5}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D6}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D7}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D8}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D9}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D10}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D11}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D12}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D13}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D14}]
set_output_delay -clock [get_clocks {cnvclk}]  -clock_fall 0.5 [get_ports {D15}]

#**************************************************************
# Set Clock Groups
#**************************************************************
set_clock_groups -exclusive -group [get_clocks {rx_clk_150}] -group [get_clocks {clk_300}]
set_clock_groups -exclusive -group [get_clocks {rx_clk_300}] -group [get_clocks {sckn}]
set_clock_groups -exclusive -group [get_clocks {rx_clk_150}] -group [get_clocks {sckn}]
set_clock_groups -exclusive -group [get_clocks {data_latch}] -group [get_clocks {sckn}]

set_clock_groups -exclusive -group [get_clocks {cnvclk}] -group [get_clocks {data_latch}]
set_clock_groups -exclusive -group [get_clocks {rx_clk_300}] -group [get_clocks {data_latch}]
set_clock_groups -exclusive -group [get_clocks {rx_clk_150}] -group [get_clocks {data_latch}]

#**************************************************************
# Set False Path
#**************************************************************

#**************************************************************
# Set Multicycle Path
#**************************************************************
set_multicycle_path -from [get_clocks {sckn}] -fall_to [get_clocks {sckn}] -setup -end 0

#**************************************************************
# Set Maximum Delay
#**************************************************************

#**************************************************************
# Set Minimum Delay
#**************************************************************

#**************************************************************
# Set Input Transition
#**************************************************************

