//Module to deserialize serial data
//DJS 6_15_16

`timescale 1ps / 1ps
module deserializer
(
	rx_start_p,
	rx_start_n,
	clk_msb,
	clk_sdr,
	clk_ddr,
	sdo,
	parallel_data_1,
	parallel_data_2,
	data_latch,
	ddr,
	num_bits
);

input rx_start_p,rx_start_n,clk_msb,clk_sdr,clk_ddr,sdo,data_latch,ddr,num_bits;
output parallel_data_1,parallel_data_2;

reg [15:0] parallel_data_1,parallel_data_2,bits_odd,bits_even;
reg [31:0] bits;
reg [5:0] cur_state,next_state,cur_state_p,next_state_p,cur_state_n,next_state_n;

wire [5:0] num_bits;
wire rx_start_p,rx_start_n,clk_msb;

parameter bit_0 = 5'd0;
parameter bit_1 = 5'd1;
parameter bit_2 = 5'd2;
parameter bit_3 = 5'd3;
parameter bit_4 = 5'd4;
parameter bit_5 = 5'd5;
parameter bit_6 = 5'd6;
parameter bit_7 = 5'd7;
parameter bit_8 = 5'd8;
parameter bit_9 = 5'd9;
parameter bit_10 = 5'd10;
parameter bit_11 = 5'd11;
parameter bit_12 = 5'd12;
parameter bit_13 = 5'd13;
parameter bit_14 = 5'd14;
parameter bit_15 = 5'd15;
parameter bit_16 = 5'd16;
parameter bit_17 = 5'd17;
parameter bit_18 = 5'd18;
parameter bit_19 = 5'd19;
parameter bit_20 = 5'd20;
parameter bit_21 = 5'd21;
parameter bit_22 = 5'd22;
parameter bit_23 = 5'd23;
parameter bit_24 = 5'd24;
parameter bit_25 = 5'd25;
parameter bit_26 = 5'd26;
parameter bit_27 = 5'd27;
parameter bit_28 = 5'd28;
parameter bit_29 = 5'd29;
parameter bit_30 = 5'd30;

initial
begin
  next_state = bit_30;
  next_state_n = bit_14;
  next_state_p = bit_15;
end

always @(posedge clk_msb)
begin
	bits[31] <= sdo;
	bits_odd[15] <= sdo;
end

always @(negedge clk_sdr) //SDR mode - load the newest bit into the serial bit array on each falling edge of 'clk'
begin
	cur_state = next_state;		 		
	case (cur_state)
	
	bit_30:  //MSB of first word
	begin	
		if(rx_start_n)
    begin
		   bits[30] <= sdo;
	     next_state <= bit_29;
	  end	
    else
      next_state <= bit_30;
  end
    	
	bit_29:
   begin
		  bits[29] <= sdo;	
	    next_state <= bit_28;
   end	
  	
	bit_28:
   begin						
		bits[28] <= sdo;			
	 next_state <= bit_27;
   end	
  	
	bit_27:
   begin
		  bits[27] <= sdo;	
	    next_state <= bit_26;
   end		
  	
	bit_26:
   begin						
		bits[26] <= sdo;		
	 next_state <= bit_25;
   end	
  	
	bit_25:
   begin
		  bits[25] <= sdo;	
	    next_state <= bit_24;
   end
  	
	bit_24:
   begin						
		bits[24] <= sdo;		
	 next_state <= bit_23;
   end	
  	
	bit_23:
   begin
		  bits[23] <= sdo;	
	    next_state <= bit_22;
   end	
  	
	bit_22:
   begin						
		bits[22] <= sdo;	
	 next_state <= bit_21;
   end	
  	
	bit_21:
   begin
		  bits[21] <= sdo;	
	    next_state <= bit_20;
   end	
    	
	bit_20:
   begin						
		bits[20] <= sdo;
		next_state <= bit_19;
   end	
    	
	bit_19:
   begin
		  bits[19] <= sdo;	
	    next_state <= bit_18;
   end
    	
	bit_18:
   begin		
		bits[18] <= sdo;		
		next_state = bit_17;
   end	
    
  bit_17:
   begin
		  bits[17] <= sdo;	
	    next_state <= bit_16;
   end	
    	
	bit_16: //LSB of first word
   begin	
		bits[16] <= sdo;
		next_state <= bit_15;
	end	

	bit_15:  //MSB of second word
   begin	
		bits[15] <= sdo;
	 next_state <= bit_14;
   end
   	
	bit_14:
   begin	
		bits[14] <= sdo;
	 next_state <= bit_13;
   end	
    	
	bit_13:
   begin
		  bits[13] <= sdo;	
	    next_state <= bit_12;
   end	
  	
	bit_12:
   begin						
		bits[12] <= sdo;			
	 next_state <= bit_11;
   end	
  	
	bit_11:
   begin
		  bits[11] <= sdo;	
	    next_state <= bit_10;
   end		
  	
	bit_10:
   begin						
		bits[10] <= sdo;		
	 next_state <= bit_9;
   end	
  	
	bit_9:
   begin
		  bits[9] <= sdo;	
	    next_state <= bit_8;
   end
  	
	bit_8:
   begin						
		bits[8] <= sdo;		
	 next_state <= bit_7;
   end	
  	
	bit_7:
   begin
		  bits[7] <= sdo;	
	    next_state <= bit_6;
   end	
  	
	bit_6:
   begin						
		bits[6] <= sdo;	
	 next_state <= bit_5;
   end	
  	
	bit_5:
   begin
		  bits[5] <= sdo;	
	    next_state <= bit_4;
   end	
    	
	bit_4:
   begin						
		bits[4] <= sdo;
		next_state <= bit_3;
   end	
    	
	bit_3:
   begin
		  bits[3] <= sdo;	
	    next_state <= bit_2;
   end
    	
	bit_2:
   begin		
		bits[2] <= sdo;		
		next_state = bit_1;
   end	
    
  bit_1:	
   begin
		  bits[1] <= sdo;	
	    next_state <= bit_0;
   end	
    	
	bit_0:  //LSB of second word
   begin	
		bits[0] <= sdo;
		next_state <= bit_30;
	end	
	    
default 	: next_state <= bit_30;

endcase
end

always @(negedge clk_ddr) //DDR mode - load the newest even bit into the serial bit array on each falling edge of 'clk'
begin
	cur_state_n = next_state_n;		 		
	case (cur_state_n)
	
	bit_14:  //MSB of first word
	begin	
		if(rx_start_n)
      begin			
		  bits_odd[14] <= sdo;
	     next_state_n <= bit_13;
      end	
    else
      next_state_n <= bit_14;
   end
   
	bit_13:
   begin	
		bits_odd[13] <= sdo;
	 next_state_n <= bit_12;
   end	
    	
	bit_12:
   begin						
		bits_odd[12] <= sdo;		
	 next_state_n <= bit_11;
   end	
  	
	bit_11:
   begin						
		bits_odd[11] <= sdo;			
	 next_state_n <= bit_10;
   end	
  	
	bit_10:
   begin						
		bits_odd[10] <= sdo;		
	 next_state_n <= bit_9;
   end	
  	    	
	bit_9:
   begin						
		bits_odd[9] <= sdo;	
		next_state_n <= bit_8;
   end	
    	
	bit_8:  //LSB of first word 
   begin	
		bits_odd[8] <= sdo;
		next_state_n <= bit_7;
	end	

	bit_7:  //MSB of second word 
   begin	
		bits_odd[7] <= sdo;
		next_state_n <= bit_6;
	end	
				
	bit_6:
   begin	
		bits_odd[6] <= sdo;
	 next_state_n <= bit_5;
   end	
    	
	bit_5:
   begin						
		bits_odd[5] <= sdo;		
	 next_state_n <= bit_4;
   end	
  	
	bit_4:
   begin						
		bits_odd[4] <= sdo;			
	 next_state_n <= bit_3;
   end	
  	
	bit_3:
   begin						
		bits_odd[3] <= sdo;		
	 next_state_n <= bit_2;
   end	
  	
	bit_2:
   begin						
		bits_odd[2] <= sdo;		
	 next_state_n <= bit_1;
   end	
  	    	
	bit_1:
   begin						
		bits_odd[1] <= sdo;	
		next_state_n <= bit_0;
   end	
    	
	bit_0:  //LSB of second word
   begin	
		bits_odd[0] <= sdo;
		next_state_n <= bit_14;
	end	
	    
default 	: next_state_n <= bit_14;

endcase
end
  
always @(posedge clk_ddr) //DDR mode - load the newest odd bit into the serial bit array on each rising edge of 'clk'
begin
	cur_state_p = next_state_p;		 		
	case (cur_state_p)
	
	bit_15:  //MSB of first word
	begin	
		if(rx_start_p)
      begin			
		  bits_even[15] <= sdo;
	     next_state_p <= bit_14;
      end	
    else
      next_state_p <= bit_15;
   end
   
	bit_14:
   begin	
		bits_even[14] <= sdo;
	 next_state_p <= bit_13;
   end	
    	
	bit_13:
   begin						
		bits_even[13] <= sdo;		
	 next_state_p <= bit_12;
   end	
  	
	bit_12:
   begin						
		bits_even[12] <= sdo;			
	 next_state_p <= bit_11;
   end	
  	
	bit_11:
   begin						
		bits_even[11] <= sdo;		
	 next_state_p <= bit_10;
   end	
  	
	bit_10:
   begin						
		bits_even[10] <= sdo;		
	 next_state_p <= bit_9;
   end	
  	    	
	bit_9:
   begin						
		bits_even[9] <= sdo;	
		next_state_p <= bit_8;
   end	
    	
	bit_8:  //LSB of first word 
   begin	
		bits_even[8] <= sdo;
		next_state_p <= bit_7;
	end	

	bit_7: //MSB of second word
   begin	
		bits_even[7] <= sdo;
	 next_state_p <= bit_6;
   end	
   			
	bit_6:
   begin	
		bits_even[6] <= sdo;
	 next_state_p <= bit_5;
   end	
    	
	bit_5:
   begin						
		bits_even[5] <= sdo;		
	 next_state_p <= bit_4;
   end	
  	
	bit_4:
   begin						
		bits_even[4] <= sdo;			
	 next_state_p <= bit_3;
   end	
  	
	bit_3:
   begin						
		bits_even[3] <= sdo;		
	 next_state_p <= bit_2;
   end	
  	
	bit_2:
   begin						
		bits_even[2] <= sdo;		
	 next_state_p <= bit_1;
   end	
  	    	
	bit_1:
   begin						
		bits_even[1] <= sdo;	
		next_state_p <= bit_0;
   end	
    	
	bit_0:  //LSB of second word
   begin	
		bits_even[0] <= sdo;
		next_state_p <= bit_15;
	end	
	    
default 	: next_state_p <= bit_15;

endcase
end

always @ (posedge data_latch)
begin
  if(ddr)
  begin
    parallel_data_1[15] <= bits_odd[15];
    parallel_data_1[14] <= bits_even[15];    
    parallel_data_1[13] <= bits_odd[14];
    parallel_data_1[12] <= bits_even[14]; 
    parallel_data_1[11] <= bits_odd[13];
    parallel_data_1[10] <= bits_even[13];    
    parallel_data_1[9] <= bits_odd[12];
    parallel_data_1[8] <= bits_even[12]; 
    parallel_data_1[7] <= bits_odd[11];
    parallel_data_1[6] <= bits_even[11];    
    parallel_data_1[5] <= bits_odd[10];
    parallel_data_1[4] <= bits_even[10]; 
    parallel_data_1[3] <= bits_odd[9];
    parallel_data_1[2] <= bits_even[9];    
    parallel_data_1[1] <= bits_odd[8];
    parallel_data_1[0] <= bits_even[8]; 

    parallel_data_2[15] <= bits_odd[7];
    parallel_data_2[14] <= bits_even[7];    
    parallel_data_2[13] <= bits_odd[6];
    parallel_data_2[12] <= bits_even[6]; 
    parallel_data_2[11] <= bits_odd[5];
    parallel_data_2[10] <= bits_even[5];    
    parallel_data_2[9] <= bits_odd[4];
    parallel_data_2[8] <= bits_even[4]; 
    parallel_data_2[7] <= bits_odd[3];
    parallel_data_2[6] <= bits_even[3];    
    parallel_data_2[5] <= bits_odd[2];
    parallel_data_2[4] <= bits_even[2]; 
    parallel_data_2[3] <= bits_odd[1];
    parallel_data_2[2] <= bits_even[1];    
    parallel_data_2[1] <= bits_odd[0];
    parallel_data_2[0] <= bits_even[0];
  end
  
  else
  begin
    parallel_data_1[15] <= bits[31];
    parallel_data_1[14] <= bits[30];    
    parallel_data_1[13] <= bits[29];
    parallel_data_1[12] <= bits[28]; 
    parallel_data_1[11] <= bits[27];
    parallel_data_1[10] <= bits[26];    
    parallel_data_1[9] <= bits[25];
    parallel_data_1[8] <= bits[24]; 
    parallel_data_1[7] <= bits[23];
    parallel_data_1[6] <= bits[22];    
    parallel_data_1[5] <= bits[21];
    parallel_data_1[4] <= bits[20]; 
    parallel_data_1[3] <= bits[19];
    parallel_data_1[2] <= bits[18];    
    parallel_data_1[1] <= bits[17];
    parallel_data_1[0] <= bits[16]; 

    parallel_data_2[15] <= bits[15];
    parallel_data_2[14] <= bits[14];    
    parallel_data_2[13] <= bits[13];
    parallel_data_2[12] <= bits[12]; 
    parallel_data_2[11] <= bits[11];
    parallel_data_2[10] <= bits[10];    
    parallel_data_2[9] <= bits[9];
    parallel_data_2[8] <= bits[8]; 
    parallel_data_2[7] <= bits[7];
    parallel_data_2[6] <= bits[6];    
    parallel_data_2[5] <= bits[5];
    parallel_data_2[4] <= bits[4]; 
    parallel_data_2[3] <= bits[3];
    parallel_data_2[2] <= bits[2];    
    parallel_data_2[1] <= bits[1];
    parallel_data_2[0] = bits[0]; 
  end
end

endmodule
